<?php

namespace backend\modules\theme\controllers;

use common\models\ThemeFiles;
use yii;
use common\models\Theme;
use yii\web\NotFoundHttpException;
use yii\web\UploadedFile;

class ThemeFileController extends \yii\web\Controller
{
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Finds the Theme model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Theme the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = ThemeFiles::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }

    public function actionUpload()
    {
        $model = new ThemeFiles();

        if ($model->load(Yii::$app->request->post())) { //&& $model->save()

            // get the uploaded file instance. for multiple file uploads
            // the following data will return an array
            $theme_file = UploadedFile::getInstance($model, 'file');

            // the path to save file,
            $folderPath = yii::getAlias('@storage/private/theme-assets/') .$model->theme_code;
            if ( ! is_dir($folderPath)) {
                mkdir($folderPath);
            }
            $path = $folderPath.'/'.$model->file_code;
            if ($model->save(false)) {
                $theme_file->saveAs($path);
            } else {
               echo 'Error';
                exit();
            }
        }

        return $this->redirect(['theme/index']);
    }

}
